

unit Unit1;

interface

uses
  Windows, Messages, SysUtils,  Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    ButtonEffacerSystemParametersInfo: TButton;
    ButtonDessiner: TButton;
    ButtonEffacerActiveDesktop: TButton;
    procedure ButtonEffacerSystemParametersInfoClick(Sender: TObject);
    procedure ButtonDessinerClick(Sender: TObject);
    procedure ButtonEffacerActiveDesktopClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses ShlObj, ComObj;

procedure TForm1.ButtonDessinerClick(Sender: TObject);
var
  HBureau:HWND;
  HDCBureau:HDC;
  CanvasBureau:TCanvas;
begin
  HBureau:=GetDesktopWindow;// rcupre le Handle du Bureau
  HDCBureau:=GetWindowDC(HBureau);
  CanvasBureau:=TCanvas.Create;
  CanvasBureau.Handle:=HDCBureau;
  CanvasBureau.LineTo(0,0);
  CanvasBureau.LineTo(200,100);
  CanvasBureau.Font.Height:=50;
  CanvasBureau.TextOut(100,100,'Hello Word');
  CanvasBureau.Brush.Style:=bsclear;  // pour avoir un fond de texte inchang
  CanvasBureau.TextOut(200,200,'Hello Word');
  ReleaseDC(HBureau,HDCBureau);
  CanvasBureau.free;
end;


procedure TForm1.ButtonEffacerActiveDesktopClick(Sender: TObject);
// rafraichissement du bureau par IActiveDesktop
//ne pas oublier uses ShlObj, ComObj;

const
  // la dclaration de CLSID_ActiveDesktop est inutile  partir de D5 (dans ShlObj)
  CLSID_ActiveDesktop: TGUID = '{75048700-EF1F-11D0-9888-006097DEACF9}'; 
var
  ActiveDesktop: IActiveDesktop;
begin
  ActiveDesktop := CreateComObject(CLSID_ActiveDesktop) as IActiveDesktop;
  ActiveDesktop.ApplyChanges(AD_APPLY_ALL or AD_APPLY_FORCE);
end;



procedure TForm1.ButtonEffacerSystemParametersInfoClick(Sender: TObject);
// rafraichissement du bureau par l'api SystemParametersInfo
// sur ma config, cette solution est la plus rapide.
begin
  SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, nil, SPIF_SENDWININICHANGE);
end;

end.


